
%define lib_major	2
%define lib_name_orig	%{package_prefix}%mklibname binutils
%define lib_name	%{lib_name_orig}%{lib_major}
%define	dev_name	%mklibname binutils -d

%define rpm_ver		2.32
%define tar_ver		2.32
%define subrel		1
%define rel		1

# Define if building a cross-binutils
%define build_cross	0
%{expand: %{?cross:	%%global build_cross 1}}

%if %{build_cross}
%define target_cpu	%{cross}
%define target_platform	%{target_cpu}-%_real_vendor-linux%{gnuext}
%define program_prefix	%{target_platform}-
%define package_prefix	cross-%{target_cpu}-
%else
%define target_cpu	%{_target_cpu}
%define target_platform	%{_target_platform}
%define program_prefix	%{nil}
%define package_prefix	%{nil}
%endif

%define arch		%(echo %{target_cpu}|sed -e "s/\(i.86\|athlon\)/i386/" -e "s/amd64/x86_64/")
%define isarch()	%(case " %* " in (*" %{arch} "*) echo 1;; (*) echo 0;; esac)

%if %{build_cross}
%if %isarch %arm
%define gnuext		-gnueabi
%else
%define gnuext		-gnu
%endif
%endif

# List of targets where gold can be enabled
%define gold_arches %{ix86} x86_64 %{arm} aarch64

Summary:	GNU Binary Utility Development Utilities
Name:		%{package_prefix}binutils
# (tmb) NOTE! Fedora does use a faked 2.23.88.*.* versioning to handle the version
#       downgrade but I dont see the point as Epoch is created for just this purpose
Epoch:		1
Version:	%{rpm_ver}
Release:	%mkrel %{rel}
License:	GPLv3+
Group:		Development/Other
URL:		http://sources.redhat.com/binutils/
Source0:	http://ftp.gnu.org/gnu/binutils/binutils-%{tar_ver}.tar.xz
Source1:	build_cross_binutils.sh
Source2:	binutils-2.19.50.0.1-output-format.sed
Source3:	binutils-git.sh
%if "%{name}" == "binutils"
Requires(post):  info-install
Requires(preun): info-install
Provides:	%{lib_name} = %{epoch}:%{version}-%{release}
%endif
# (tmb) force build with gcc 5.5.0
BuildRequires:	gcc >= 5.5.0-1
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	gettext
BuildRequires:	texinfo-tex
BuildRequires:	dejagnu
BuildRequires:	pkgconfig(zlib)
# make check'ing requires libdl.a
BuildRequires:	glibc-static-devel
# gold make check'ing requires libstdc++.a
BuildRequires:	libstdc++-static-devel

# upstream 2.32 branch
# Created with binutils-git.sh
# (tmb) disble development mode
#Patch101:	binutils-bfd-disable-development-mode.patch
Patch100:	0100-Updated-Swedish-translation-for-the-opcodes-sub-dire.patch
Patch101:	0101-Arm-Backport-hlt-to-all-architectures.patch
Patch102:	0102-x86-64-Restore-PIC-check-for-PCREL-reloc-against-pro.patch
Patch103:	0103-gas-Pass-max_bytes-to-TC_FRAG_INIT.patch
Patch104:	0104-AArch64-Fix-disassembler-bug-with-out-of-order-secti.patch
Patch105:	0105-BINUTILS-AArch64-1-2-Add-new-LDGM-STGM-instruction.patch
Patch106:	0106-BINUTILS-AArch64-2-2-Update-Store-Allocation-Tag-ins.patch
Patch107:	0107-x86-Also-check-x86-linker_def-for-non-shared-definit.patch
Patch108:	0108-AArch64-When-DF_BIND_NOW-don-t-use-TLSDESC-GOT-value.patch

# Fedora patches:
Patch01:	binutils-2.20.51.0.2-libtool-lib64.patch
# We don't want this one!
# (tmb disabled) Patch02:	binutils-2.25-version.patch
# Local patch - export demangle.h with the binutils-devel rpm.
Patch03:	binutils-2.32-export-demangle.h.patch
# Disable checks that config.h has been included before system headers.  BZ #845084
Patch04:	binutils-2.22.52.0.4-no-config-h-check.patch
# Import H.J.Lu's Kernel LTO patch.
# (tmb disabled) Patch05:	binutils-2.26-lto.patch
# Include the filename concerned in readelf error messages.
Patch06:	binutils-2.29-filename-in-error-messages.patch
# Revert PR 23161 as it breaks builds
Patch11:	binutils-do-not-provide-shared-section-symbols.patch
# ignore gold dups, still not fixed upstream
Patch16:	binutils-2.28-ignore-gold-duplicates.patch

# Mageia patches
# TODO: should really clean up this patch again now...
Patch51:	binutils-2.32-linux32.patch
Patch52:	binutils-2.31.1-skip-gold-check.patch

# security fixes
Patch500:	binutils-CVE-2019-9071.patch
Patch501:	binutils-CVE-2019-9073.patch
Patch502:	binutils-CVE-2019-9074.patch
Patch503:	binutils-CVE-2019-9075.patch
Patch504:	binutils-CVE-2019-9077.patch

%description
Binutils is a collection of binary utilities, including:

   * ar: creating modifying and extracting from archives
   * nm: for listing symbols from object files
   * objcopy: for copying and translating object files
   * objdump: for displaying information from object files
   * ranlib: for generating an index for the contents of an archive
   * size: for listing the section sizes of an object or archive file
   * strings: for listing printable strings from files
   * strip: for discarding symbols (a filter for demangling encoded C++ symbols
   * addr2line: for converting addresses to file and line
   * nlmconv: for converting object code into an NLM

Install binutils if you need to perform any of these types of actions on
binary files.  Most programmers will want to install binutils.

%package -n	%{dev_name}
Summary:	Main library for %{name}
Group:		Development/Other
Provides:	%{name}-devel = %{epoch}:%{version}-%{release}
Provides:	%{lib_name}-devel = %{epoch}:%{version}-%{release}
Requires:	zlib-devel

%description -n	%{dev_name}
This package contains BFD and opcodes static libraries and associated
header files.  Only *.a libraries are included, because BFD doesn't
have a stable ABI.  Developers starting new projects are strongly encouraged
to consider using libelf instead of BFD.

%prep
%setup -q -n binutils-%{tar_ver}
%autopatch -p1

%build
# Additional targets
ADDITIONAL_TARGETS=""
case %{target_cpu} in
i*86 | athlon*)
  ADDITIONAL_TARGETS="x86_64-%{_target_vendor}-%{_target_os}"
  ;;
esac
if [[ -n "$ADDITIONAL_TARGETS" ]]; then
  TARGET_CONFIG="$TARGET_CONFIG --enable-targets=$ADDITIONAL_TARGETS"
fi

case %{target_cpu} in
i*86 | athlon* | aarch64*)
  TARGET_CONFIG="$TARGET_CONFIG --enable-64-bit-bfd"
  ;;
esac

case %{target_cpu} in x86_64*|i?86*|arm*|aarch64*)
  TARGET_CONFIG="$TARGET_CONFIG --enable-targets=x86_64-pep"
  ;;
esac

%if "%{name}" != "binutils"
%define _program_prefix %{program_prefix}
TARGET_CONFIG="$TARGET_CONFIG --target=%{target_platform}"
%endif

# Don't build shared libraries in cross binutils
%if "%{name}" == "binutils"
TARGET_CONFIG="$TARGET_CONFIG --enable-shared --with-pic"
%endif

# Binutils comes with its own custom libtool
# [gb] FIXME: but system libtool also works and has relink fix
%define __libtoolize /bin/true

# Build main binaries
rm -rf objs
mkdir objs
pushd objs
CONFIGURE_TOP=.. %configure2_5x $TARGET_CONFIG	--with-bugurl=https://bugs.mageia.org/ \
						--enable-gold \
						--enable-plugins \
						--enable-relro=yes
# There seems to be some problems with builds of gold randomly failing whenever
# going through the build system, so let's try workaround this by trying to do
# make once again when it happens...
%make_build tooldir=%{_prefix} || make tooldir=%{_prefix}
popd

%check
# All Tests must pass on x86 and x86_64
# rtp: some ld-arm tests are failing.
# they're fixed in 2.21 but didn't find the fixes
echo ====================TESTING=========================
%if %isarch i386 x86_64
%make_build -C objs check LDFLAGS="" || :
# random build failures with gold seems to happen during check as well...
make -k -C objs gold-check LDFLAGS="" || :
%else
%make_build -C objs -k check LDFLAGS="" || :
%endif
echo ====================TESTING END=====================

logfile="%{name}-%{version}-%{release}.log"
rm -f $logfile; find . -name "*.sum" | xargs cat >> $logfile

%install
mkdir -p $RPM_BUILD_ROOT%{_prefix}
%make_install -C objs

rm -f $RPM_BUILD_ROOT%{_mandir}/man1/{dlltool,nlmconv,windres}*
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/lib{bfd,opcodes}.so

%if "%{name}" == "binutils"
make -C objs prefix=$RPM_BUILD_ROOT%{_prefix} infodir=$RPM_BUILD_ROOT%{_infodir} install-info
install -m 644 include/libiberty.h $RPM_BUILD_ROOT%{_includedir}/
%if %isarch %mips
install -m 644 objs/libiberty/libiberty.a $RPM_BUILD_ROOT%{_libdir}/
# Ship with the PIC libiberty
%else
install -m 644 objs/libiberty/pic/libiberty.a $RPM_BUILD_ROOT%{_libdir}/
%endif
rm -rf $RPM_BUILD_ROOT%{_prefix}/%{_target_platform}/

# Sanity check --enable-64-bit-bfd really works.
%if %isarch i*86 athlon*
grep '^#define BFD_ARCH_SIZE 64$' %{buildroot}%{_prefix}/include/bfd.h
%endif

# Fix multilib conflicts of generated values by __WORDSIZE-based expressions.
%if %isarch %{ix86} x86_64
sed -i -e '/^#include "ansidecl.h"/{p;s~^.*$~#include <bits/wordsize.h>~;}' \
    -e 's/^#define BFD_DEFAULT_TARGET_SIZE \(32\|64\) *$/#define BFD_DEFAULT_TARGET_SIZE __WORDSIZE/' \
    -e 's/^#define BFD_HOST_64BIT_LONG [01] *$/#define BFD_HOST_64BIT_LONG (__WORDSIZE == 64)/' \
    -e 's/^#define BFD_HOST_64_BIT \(long \)\?long *$/#if __WORDSIZE == 32\
#define BFD_HOST_64_BIT long long\
#else\
#define BFD_HOST_64_BIT long\
#endif/' \
    -e 's/^#define BFD_HOST_U_64_BIT unsigned \(long \)\?long *$/#define BFD_HOST_U_64_BIT unsigned BFD_HOST_64_BIT/' \
    %{buildroot}%{_prefix}/include/bfd.h
%endif
touch -r bfd/bfd-in2.h %{buildroot}%{_prefix}/include/bfd.h

# Generate .so linker scripts for dependencies; imported from glibc/Makerules:

# This fragment of linker script gives the OUTPUT_FORMAT statement
# for the configuration we are building.
OUTPUT_FORMAT="\
/* Ensure this .so library will not be used by a link for a different format
   on a multi-architecture system.  */
$(gcc $CFLAGS $LDFLAGS -shared -x c /dev/null -o /dev/null -Wl,--verbose -v 2>&1 | sed -n -f "%{SOURCE2}")"

tee %{buildroot}%{_libdir}/libbfd.so <<EOH
/* GNU ld script */

$OUTPUT_FORMAT

/* The libz dependency is unexpected by legacy build scripts.  */
INPUT ( %{_libdir}/libbfd.a -liberty -lz )
EOH

tee %{buildroot}%{_libdir}/libopcodes.so <<EOH
/* GNU ld script */

$OUTPUT_FORMAT

INPUT ( %{_libdir}/libopcodes.a -lbfd -lz )
EOH

%else
rm -f  $RPM_BUILD_ROOT%{_libdir}/libiberty.a
rm -rf $RPM_BUILD_ROOT%{_infodir}
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/
rm -f  $RPM_BUILD_ROOT%{_prefix}/%{_target_platform}/%{target_cpu}-linux/lib/*.la
%endif

%find_lang binutils
%find_lang gas
%find_lang ld
%find_lang gold
%find_lang gprof
cat gas.lang >> binutils.lang
cat ld.lang >> binutils.lang
cat gold.lang>> binutils.lang
cat gprof.lang >> binutils.lang

%find_lang opcodes
%find_lang bfd
cat opcodes.lang >> binutils.lang
cat bfd.lang >> binutils.lang

%if "%{name}" == "binutils"
%post
%_install_info as.info
%_install_info bfd.info
%_install_info binutils.info
%_install_info gasp.info
%_install_info gprof.info
%_install_info ld.info
%_install_info standards.info
%endif

%if "%{name}" == "binutils"
%preun
%_remove_install_info as.info
%_remove_install_info bfd.info
%_remove_install_info binutils.info
%_remove_install_info gasp.info
%_remove_install_info gprof.info
%_remove_install_info ld.info
%_remove_install_info standards.info
%endif

%files -f binutils.lang
%{_bindir}/%{program_prefix}addr2line
%{_bindir}/%{program_prefix}ar
%{_bindir}/%{program_prefix}as
%{_bindir}/%{program_prefix}c++filt
%{_bindir}/%{program_prefix}dwp
%{_bindir}/%{program_prefix}elfedit
%{_bindir}/%{program_prefix}gprof
%{_bindir}/%{program_prefix}ld
%{_bindir}/%{program_prefix}ld.bfd
%if %isarch %{gold_arches}
%{_bindir}/%{program_prefix}ld.gold
%endif
%{_bindir}/%{program_prefix}nm
%{_bindir}/%{program_prefix}objcopy
%{_bindir}/%{program_prefix}objdump
%{_bindir}/%{program_prefix}ranlib
%{_bindir}/%{program_prefix}readelf
%{_bindir}/%{program_prefix}size
%{_bindir}/%{program_prefix}strings
%{_bindir}/%{program_prefix}strip
%{_mandir}/man1/*
%if "%{name}" == "binutils"
%{_infodir}/*info*
%{_libdir}/libbfd-%{version}*.so
%{_libdir}/libopcodes-%{version}*.so
%else
%{_prefix}/%{target_platform}/bin/*
%{_prefix}/%{target_platform}/lib/ldscripts
%endif

%if "%{name}" == "binutils"
%files -n %{dev_name}
%{_includedir}/*.h
%{_libdir}/libbfd.a
%{_libdir}/libbfd.so
%{_libdir}/libopcodes.a
%{_libdir}/libopcodes.so
%{_libdir}/libiberty.a
%endif


%changelog
* Thu May 02 2019 tmb <tmb> 1:2.32-1.1.mga6
+ Revision: 1396137
- sync with binutils-2.32-6.mga7 and fix CVE-2019-9071/3/4/5/7
- sync with cauldron 2.32-3

* Sat Jul 01 2017 akien <akien> 1:2.25.1-7.mga6
+ Revision: 1108880
- Add FSF binutils patch to fix running readelf on debug info binaries (rhbz#1434050)

* Sat Jul 01 2017 tmb <tmb> 1:2.25.1-6.mga6
+ Revision: 1108788
- fix CVE-2016-4487/4488/4489/4490/4492/4493/6131 and CVE-2017-6969/7210
+ neoclust <neoclust>
- Add P1000 - Fixes CVE-2016-2226 (mga#18987)

* Wed Feb 10 2016 umeabot <umeabot> 1:2.25.1-5.mga6
+ Revision: 953250
- Mageia 6 Mass Rebuild

* Thu Aug 20 2015 tmb <tmb> 1:2.25.1-4.mga6
+ Revision: 866990
- rebuild with new gcc

* Thu Aug 20 2015 tmb <tmb> 1:2.25.1-3.mga6
+ Revision: 866658
- rebuild with gcc 5.2.1

* Tue Aug 18 2015 tmb <tmb> 1:2.25.1-2.mga6
+ Revision: 865415
- rebuild with new glibc

* Sun Aug 02 2015 tmb <tmb> 1:2.25.1-1.mga6
+ Revision: 860852
- push to /release

* Fri Jul 31 2015 tmb <tmb> 1:2.25.1-0.1.mga6
+ Revision: 859934
- rebase linux32 patch
- drop merged / obsolete patches
- resync current fedora patches
- update to 2.25.1

* Wed Jan 14 2015 cjw <cjw> 1:2.24-12.mga5
+ Revision: 810639
- patch105: fix for CVE-2014-8738 (mga #15022)

* Thu Dec 04 2014 cjw <cjw> 1:2.24-11.mga5
+ Revision: 801533
- add more patches from fedora:
  + patch20: Fix decoding of abbrevs using a DW_FORM_ref_addr attribute.
  + patch21: Fix detection of uncompressed .debug_str sections.
  + patch22: Default to -ffat-lto-objects for some ld tests, which was the default in gcc 4.8, but changed in 4.9, and resulted in some failures.
  + patch23: Scan all input files for symbol reference warning.
  + patch26: Backport of fix from HEAD that fixes LTO + ifunc when using ld.bfd instead of gold.
  + patch27: Fix reading of corrupt ELF binaries.
  + patch28: Default strings command to using -a.
  + patch29: Fix problems with the ar program reported in FSF PR 17533.
- patch53: fix ar segfaulting on --plugin, caused by patch16
- patch104: fix compilation with gcc 4.9 and -Werror
- fix patch51 for -Werror
- don't disable -Werror

* Wed Oct 15 2014 umeabot <umeabot> 1:2.24-10.mga5
+ Revision: 743839
- Second Mageia 5 Mass Rebuild

* Thu Sep 18 2014 umeabot <umeabot> 1:2.24-9.mga5
+ Revision: 693506
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 1:2.24-8.mga5
+ Revision: 678155
- Mageia 5 Mass Rebuild

* Thu Sep 11 2014 tmb <tmb> 1:2.24-7.mga5
+ Revision: 674672
- rebuild with new glibc and gcc

* Sun Jun 29 2014 tmb <tmb> 1:2.24-6.mga5
+ Revision: 640988
- x86_64.cc (Target_x86_64::Relocate::relocate): Add missing break
- Fix buffer underrun in i386-dis.c

* Tue May 13 2014 tmb <tmb> 1:2.24-5.mga5
+ Revision: 622526
- rebuild with gcc 4.9

* Mon Feb 17 2014 tmb <tmb> 1:2.24-4.mga5
+ Revision: 593944
- rebuild with new glibc

* Sun Jan 05 2014 tmb <tmb> 1:2.24-3.mga4
+ Revision: 564777
- bfd/elflink: Correct elf_merge_st_other arguments for weak symbols

* Sat Dec 14 2013 tmb <tmb> 1:2.24-2.mga4
+ Revision: 556837
- Fix --as-needed undefined symbol references from dynamic libraries

* Wed Dec 04 2013 tmb <tmb> 1:2.24-1.mga4
+ Revision: 555184
- update to 2.24 final

* Tue Oct 22 2013 umeabot <umeabot> 1:2.24-0.20131016.2.mga4
+ Revision: 545616
- Mageia 4 Mass Rebuild

* Wed Oct 16 2013 tmb <tmb> 1:2.24-0.20131016.1.mga4
+ Revision: 501464
- update to 2013-10-16 snapshot

* Sat Oct 12 2013 tmb <tmb> 1:2.24-0.20131012.1.mga4
+ Revision: 495973
- update to 2013-10-12 git checkout
- drop merged/obsolete patches
- update to 2.24 (checkout 2013-10-11)

* Sun Aug 11 2013 tmb <tmb> 1:2.23.2-2.mga4
+ Revision: 465387
- rebuild with new gcc

* Sun Aug 11 2013 tmb <tmb> 1:2.23.2-1.mga4
+ Revision: 465372
- push to /release

* Thu Aug 01 2013 tmb <tmb> 1:2.23.2-0.3.mga4
+ Revision: 462059
- rebuild with gcc-4.8.2

* Sun Jul 28 2013 tmb <tmb> 1:2.23.2-0.2.mga4
+ Revision: 459704
- sync patches with fedora
- renumber mga patches
- sync patches to apply cleanly
- fix tarball name
- use https in bugurl
- drop redundant obsoletes
- drop redundant requires
- drop obsolete conflicts
- switch back to official stable FSF binutils 2.23.2 (like Fedora)
  (reasoning: current kernel binutils is too unstable and has too
   many controversial patches)

* Sun Apr 07 2013 rtp <rtp> 2.23.51.0.8-3.mga3
+ Revision: 408971
- disable again tests as the source is still the same
- backport PR/14887 fix.
+ tmb <tmb>
- re-enable checks

* Wed Jan 09 2013 tmb <tmb> 2.23.51.0.8-2.mga3
+ Revision: 344128
- temporarily ignore 3 failing tests like fedora
- fix -set-long-long and -commit-h-check patches not applied due to renumbering in commit 284621
- rediff P8 (-relro by default)
- update to 2.23.51.0.8
- drop P11 (not applied, merged upstream long time ago)
- update bugurl
- update filelists
- sync P2 with fedora
- update to 2.23.51.0.5
- update to 2.23.51.0.3
- rebuild with new gcc

* Mon Aug 27 2012 tv <tv> 2.23.51.0.1-5.mga3
+ Revision: 284622
- new release (improved dwz support for valgrind)
- resync patches with FC
- rediff patch 21

* Wed Jul 18 2012 tmb <tmb> 2.22-5.mga3
+ Revision: 272351
- rebuild for new glibc

* Wed Jun 27 2012 tmb <tmb> 2.22-4.mga3
+ Revision: 264207
- rebuild with gcc-4.7.1

* Sat Mar 03 2012 tmb <tmb> 2.22-3.mga2
+ Revision: 217205
- rebuild with new gcc

* Tue Dec 06 2011 fwang <fwang> 2.22-2.mga2
+ Revision: 177220
- rebuild for new gcc

* Mon Nov 28 2011 rtp <rtp> 2.22-1.mga2
+ Revision: 173834
- Update to binutils 2.22. Test suite clean on 32/64 and nearly clean on arm
  (but still less failures than previous version)
- rediff patch21

* Mon Jun 27 2011 rtp <rtp> 2.21.52.0.1-1.mga2
+ Revision: 114591
- update to 2.21.52.0.1
- drop merged patches
- rediff linux32, build-id, skip-gold-check patches
- drop mips ihex patch. Was not used (even at mdv), so no need to keep
  it forever
- drop ld-selective45-x86_64-xfail as it's no more needed

* Mon Mar 21 2011 rtp <rtp> 2.20.51.0.11-2.mga1
+ Revision: 75232
- fix bug url
- drop old mips patches
- backport PR/12339
- revert isarch to "old" version to get working macros like %%arm %%mips working
- change a ifarch to a if isarch
- add missing if isarch.

* Tue Jan 11 2011 pterjan <pterjan> 2.20.51.0.11-1.mga1
+ Revision: 6171
- Do not use manbo tag
+ blino <blino>
- imported package binutils

